hdu 2825 (Aho-Corasick & 状压DP) - xgtao -

题目链接

给出m(m<=10)个模板串,问长度为n(n<=25)的字符串包含至少k个模板串的种类数,对20090717取模。

套路,有多个模板串考虑Aho-Corasick,因为想了很久找不到什么可行办法做,就考虑Dp,因为m<=10,所以可以有状压来检查当前状态下已经包含多少个模板串了,因为在一棵trie树上,那么定义状态也好定义,dp[len][id][s]表示长度为len时处在第id个节点并且状态为s,转移方程为dp[len+1][nextid][s|nexts] += dp[len][id][s],因为内存够用我就没有用滚动数组了,最后再把s中大于等于k个的状态的长度为n的所有节点的dp值加起来。

#include <cstdio>
#include <iostream>
#include <queue>
#include <cstring>
#include <algorithm>
#define LL long long
using namespace std;

//Globel define
const int N = 30;
const int alp = 26;
const int mod = 20090717;
int n,m,k;
int ncnt;
int dp[N][110][1035];
struct node{
	int id,set;
	node *ch[alp],*fail;
	void init(){
		set = 0;
		for(int i = 0;i < alp;++i)ch[i] = NULL;
	}
}trie[110];
//end Globel define

node *newnode(){
	node *p = &trie[ncnt];
	p->init();
	p->id = ncnt++;
	return p;
}

void insert(node *root,char *s,int i){
	node *p = root;
	int set = 0;
	while(*s != ‘\0‘){
		if(!p->ch[*s-‘a‘])p->ch[*s-‘a‘] = newnode();
		p = p->ch[*s-‘a‘];
		++s;
	}
	p->set |= (1<<i);
}

void _buildfail(node *root){
	queue <node *> q;
	root->fail = NULL;
	q.push(root);
	while(!q.empty()){
		node *p = q.front();q.pop();
		for(int i = 0;i < alp;++i){
			if(p->ch[i]){
				node *next = p->fail;
				while(next && !next->ch[i])next = next->fail;
				p->ch[i]->fail = next ? next->ch[i] : root;
				p->ch[i]->set |= p->ch[i]->fail->set;
				q.push(p->ch[i]);
			}
			else p->ch[i] = (p==root) ? root:p->fail->ch[i];
		}
	}
}

int count(int set){
	int cnt = 0;
	for(int i = 0;i < 10;++i){
		if(set&(1<<i))cnt++;
	}
	return cnt;
}

int main(){
	while(scanf("%d%d%d",&n,&m,&k) && n+m+k){
		ncnt = 0;
		memset(trie,0,sizeof(trie));
		node *root = newnode();
		for(int i = 0;i < m;++i){
			char buf[N];
			scanf("%s",buf);
			insert(root,buf,i);
		}
		_buildfail(root);
		memset(dp,0,sizeof(dp));

		dp[0][0][0] = 1;
		for(int a = 0;a < n;++a)
		for(int b = 0;b < ncnt;++b)
		for(int s = 0;s < (1<<m);++s){
			if(!dp[a][b][s])continue;
			for(int c = 0;c < alp;++c){
				node *nxt = trie[b].ch[c];
				if(!nxt)continue;
				int &ret = dp[a+1][nxt->id][s|nxt->set];
				ret = (ret+dp[a][b][s])%mod;
			}
		}
		int ans = 0;
		for(int s = 0;s < (1<<m);++s){
			if(count(s)>=k){
				for(int i = 0;i < ncnt;++i)ans = (ans+dp[n][i][s])%mod;
			}
		}
		cout<<ans<<endl;
	}
	return 0;
}

  

时间: 2024-11-23 14:43:03

hdu 2825 (Aho-Corasick & 状压DP) - xgtao -的相关文章

hdu 2825 aC自动机+状压dp

Wireless Password Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 5640    Accepted Submission(s): 1785 Problem Description Liyuan lives in a old apartment. One day, he suddenly found that there

HDU 4924 Football Manager(状压DP)

题目连接 : http://acm.hdu.edu.cn/showproblem.php?pid=4924 题意 : n(<=20)个人选出11个人作为首发组成a-b-c阵容,每个人都有自己擅长的位置,并且每个人和其他人会有单向的厌恶和喜欢关系,每个人对于自己擅长的位置都有两个值CA和PA,有喜欢或者厌恶关系的两个人在一起也会影响整个首发的CA总值,要求选出一套阵容使得CA最大,或者CA一样的情况下PA最大. 思路 : 状压搞,dp[s]s的二进制表示20个人中选了那几个人,然后规定选进来的顺序

hdu 3247 AC自动+状压dp+bfs处理

Resource Archiver Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others)Total Submission(s): 2382    Accepted Submission(s): 750 Problem Description Great! Your new software is almost finished! The only thing left to

HDU 1074 Doing Homework(状压DP)

Problem Description Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will r

HDU 5765 Bonds(状压DP)

[题目链接] http://acm.hdu.edu.cn/showproblem.php?pid=5765 [题目大意] 给出一张图,求每条边在所有边割集中出现的次数. [题解] 利用状压DP,计算不同的连通块,对于每条边,求出两边的联通块的划分方案数,就是对于该点的答案. [代码] #include <cstdio> #include <algorithm> #include <cstring> using namespace std; int n,m,T,Cas=1

hdu 4778 Gems Fight! 状压dp

转自wdd :http://blog.csdn.net/u010535824/article/details/38540835 题目链接:hdu 4778 状压DP 用DP[i]表示从i状态选到结束得到的最大值 代码也来自wdd 1 /****************************************************** 2 * File Name: b.cpp 3 * Author: kojimai 4 * Creater Time:2014年08月13日 星期三 11时

HDU 3001 Travelling (状压DP,3进制)

题意: 给出n<=10个点,有m条边的无向图.问:可以从任意点出发,至多经过同一个点2次,遍历所有点的最小费用? 思路: 本题就是要卡你的内存,由于至多可经过同一个点2次,所以只能用3进制来表示,3进制可以先将表打出来.在走的时候注意只能走2次,其他的和普通的TSP状压DP是一样的.注意点:重边,自环等等,老梗了. 1 //#include <bits/stdc++.h> 2 #include <iostream> 3 #include <cstdio> 4 #i

HDU 4628 Pieces(状压DP)题解

题意:n个字母,每次可以删掉一组非连续回文,问你最少删几次 思路:把所有回文找出来,然后状压DP 代码: #include<set> #include<map> #include<cmath> #include<queue> #include<cstdio> #include<vector> #include<cstring> #include <iostream> #include<algorithm&

HDU 4623 Crime (状压DP + 数学优化)

题目:传送门 题意:问存在多少 1 ~ n 的排列满足任意相邻的两个数互质,输出答案取余 mod.     1 <= n <= 28, 1 <= mod <= 30000 思路:很容易想到状压DP, dp[ i ][ j ]其中 i 是最后一个数要填的数,j 是当前使用过的数的状态,每一个二进制位对应一个数.也就是还没填 i 时使用过的数的状态为 j 的满足条件的方案数.     然后发现 2^28 开不了数组,没法做,得想办法优化一下. 我们对那些拥有相同质因子的数分为同一类,例